test-lib: Work around incompatible sort and find on Windows
[git/dscho.git] / git-submodule.sh
blob0a27232b90456b5471ee64d5dcf9965ad73f28af
1 #!/bin/sh
3 # git-submodules.sh: add, init, update or list git submodules
5 # Copyright (c) 2007 Lars Hjemli
7 USAGE="[--quiet] [--cached] \
8 [add <repo> [-b branch] <path>]|[status|init|update [-i|--init] [-N|--no-fetch]|summary [-n|--summary-limit <n>] [<commit>]] \
9 [--] [<path>...]|[foreach <command>]|[sync [--] [<path>...]]"
10 OPTIONS_SPEC=
11 . git-sh-setup
12 . git-parse-remote
13 require_work_tree
15 command=
16 branch=
17 quiet=
18 cached=
19 nofetch=
22 # print stuff on stdout unless -q was specified
24 say()
26 if test -z "$quiet"
27 then
28 echo "$@"
32 # Resolve relative url by appending to parent's url
33 resolve_relative_url ()
35 remote=$(get_default_remote)
36 remoteurl=$(git config "remote.$remote.url") ||
37 die "remote ($remote) does not have a url defined in .git/config"
38 url="$1"
39 remoteurl=${remoteurl%/}
40 while test -n "$url"
42 case "$url" in
43 ../*)
44 url="${url#../}"
45 remoteurl="${remoteurl%/*}"
47 ./*)
48 url="${url#./}"
51 break;;
52 esac
53 done
54 echo "$remoteurl/${url%/}"
58 # Get submodule info for registered submodules
59 # $@ = path to limit submodule list
61 module_list()
63 git ls-files --error-unmatch --stage -- "$@" | grep '^160000 '
67 # Map submodule path to submodule name
69 # $1 = path
71 module_name()
73 # Do we have "submodule.<something>.path = $1" defined in .gitmodules file?
74 re=$(printf '%s\n' "$1" | sed -e 's/[].[^$\\*]/\\&/g')
75 name=$( git config -f .gitmodules --get-regexp '^submodule\..*\.path$' |
76 sed -n -e 's|^submodule\.\(.*\)\.path '"$re"'$|\1|p' )
77 test -z "$name" &&
78 die "No submodule mapping found in .gitmodules for path '$path'"
79 echo "$name"
83 # Clone a submodule
85 # Prior to calling, cmd_update checks that a possibly existing
86 # path is not a git repository.
87 # Likewise, cmd_add checks that path does not exist at all,
88 # since it is the location of a new submodule.
90 module_clone()
92 path=$1
93 url=$2
95 # If there already is a directory at the submodule path,
96 # expect it to be empty (since that is the default checkout
97 # action) and try to remove it.
98 # Note: if $path is a symlink to a directory the test will
99 # succeed but the rmdir will fail. We might want to fix this.
100 if test -d "$path"
101 then
102 rmdir "$path" 2>/dev/null ||
103 die "Directory '$path' exist, but is neither empty nor a git repository"
106 test -e "$path" &&
107 die "A file already exist at path '$path'"
109 git-clone -n "$url" "$path" ||
110 die "Clone of '$url' into submodule path '$path' failed"
114 # Add a new submodule to the working tree, .gitmodules and the index
116 # $@ = repo path
118 # optional branch is stored in global branch variable
120 cmd_add()
122 # parse $args after "submodule ... add".
123 while test $# -ne 0
125 case "$1" in
126 -b | --branch)
127 case "$2" in '') usage ;; esac
128 branch=$2
129 shift
131 -q|--quiet)
132 quiet=1
135 shift
136 break
139 usage
142 break
144 esac
145 shift
146 done
148 repo=$1
149 path=$2
151 if test -z "$repo" -o -z "$path"; then
152 usage
155 # assure repo is absolute or relative to parent
156 case "$repo" in
157 ./*|../*)
158 # dereference source url relative to parent's url
159 realrepo=$(resolve_relative_url "$repo") || exit
161 *:*|/*)
162 # absolute url
163 realrepo=$repo
166 die "repo URL: '$repo' must be absolute or begin with ./|../"
168 esac
170 # normalize path:
171 # multiple //; leading ./; /./; /../; trailing /
172 path=$(printf '%s/\n' "$path" |
173 sed -e '
174 s|//*|/|g
175 s|^\(\./\)*||
176 s|/\./|/|g
177 :start
178 s|\([^/]*\)/\.\./||
179 tstart
180 s|/*$||
182 git ls-files --error-unmatch "$path" > /dev/null 2>&1 &&
183 die "'$path' already exists in the index"
185 # perhaps the path exists and is already a git repo, else clone it
186 if test -e "$path"
187 then
188 if test -d "$path"/.git -o -f "$path"/.git
189 then
190 echo "Adding existing repo at '$path' to the index"
191 else
192 die "'$path' already exists and is not a valid git repo"
195 case "$repo" in
196 ./*|../*)
197 url=$(resolve_relative_url "$repo") || exit
200 url="$repo"
202 esac
203 git config submodule."$path".url "$url"
204 else
206 module_clone "$path" "$realrepo" || exit
207 (unset GIT_DIR; cd "$path" && git checkout -f -q ${branch:+-b "$branch" "origin/$branch"}) ||
208 die "Unable to checkout submodule '$path'"
211 git add "$path" ||
212 die "Failed to add submodule '$path'"
214 git config -f .gitmodules submodule."$path".path "$path" &&
215 git config -f .gitmodules submodule."$path".url "$repo" &&
216 git add .gitmodules ||
217 die "Failed to register submodule '$path'"
221 # Execute an arbitrary command sequence in each checked out
222 # submodule
224 # $@ = command to execute
226 cmd_foreach()
228 module_list |
229 while read mode sha1 stage path
231 if test -e "$path"/.git
232 then
233 say "Entering '$path'"
234 (cd "$path" && eval "$@") ||
235 die "Stopping at '$path'; script returned non-zero status."
237 done
241 # Register submodules in .git/config
243 # $@ = requested paths (default to all)
245 cmd_init()
247 # parse $args after "submodule ... init".
248 while test $# -ne 0
250 case "$1" in
251 -q|--quiet)
252 quiet=1
255 shift
256 break
259 usage
262 break
264 esac
265 shift
266 done
268 module_list "$@" |
269 while read mode sha1 stage path
271 # Skip already registered paths
272 name=$(module_name "$path") || exit
273 url=$(git config submodule."$name".url)
274 test -z "$url" || continue
276 url=$(git config -f .gitmodules submodule."$name".url)
277 test -z "$url" &&
278 die "No url found for submodule path '$path' in .gitmodules"
280 # Possibly a url relative to parent
281 case "$url" in
282 ./*|../*)
283 url=$(resolve_relative_url "$url") || exit
285 esac
287 git config submodule."$name".url "$url" ||
288 die "Failed to register url for submodule path '$path'"
290 say "Submodule '$name' ($url) registered for path '$path'"
291 done
295 # Update each submodule path to correct revision, using clone and checkout as needed
297 # $@ = requested paths (default to all)
299 cmd_update()
301 # parse $args after "submodule ... update".
302 while test $# -ne 0
304 case "$1" in
305 -q|--quiet)
306 shift
307 quiet=1
309 -i|--init)
310 shift
311 cmd_init "$@" || return
313 -N|--no-fetch)
314 shift
315 nofetch=1
318 shift
319 break
322 usage
325 break
327 esac
328 done
330 module_list "$@" |
331 while read mode sha1 stage path
333 name=$(module_name "$path") || exit
334 url=$(git config submodule."$name".url)
335 if test -z "$url"
336 then
337 # Only mention uninitialized submodules when its
338 # path have been specified
339 test "$#" != "0" &&
340 say "Submodule path '$path' not initialized" &&
341 say "Maybe you want to use 'update --init'?"
342 continue
345 if ! test -d "$path"/.git -o -f "$path"/.git
346 then
347 module_clone "$path" "$url" || exit
348 subsha1=
349 else
350 subsha1=$(unset GIT_DIR; cd "$path" &&
351 git rev-parse --verify HEAD) ||
352 die "Unable to find current revision in submodule path '$path'"
355 if test "$subsha1" != "$sha1"
356 then
357 force=
358 if test -z "$subsha1"
359 then
360 force="-f"
363 if test -z "$nofetch"
364 then
365 (unset GIT_DIR; cd "$path" &&
366 git-fetch) ||
367 die "Unable to fetch in submodule path '$path'"
370 (unset GIT_DIR; cd "$path" &&
371 git-checkout $force -q "$sha1") ||
372 die "Unable to checkout '$sha1' in submodule path '$path'"
374 say "Submodule path '$path': checked out '$sha1'"
376 done
379 set_name_rev () {
380 revname=$( (
381 unset GIT_DIR
382 cd "$1" && {
383 git describe "$2" 2>/dev/null ||
384 git describe --tags "$2" 2>/dev/null ||
385 git describe --contains "$2" 2>/dev/null ||
386 git describe --all --always "$2"
389 test -z "$revname" || revname=" ($revname)"
392 # Show commit summary for submodules in index or working tree
394 # If '--cached' is given, show summary between index and given commit,
395 # or between working tree and given commit
397 # $@ = [commit (default 'HEAD'),] requested paths (default all)
399 cmd_summary() {
400 summary_limit=-1
401 for_status=
403 # parse $args after "submodule ... summary".
404 while test $# -ne 0
406 case "$1" in
407 --cached)
408 cached="$1"
410 --for-status)
411 for_status="$1"
413 -n|--summary-limit)
414 if summary_limit=$(($2 + 0)) 2>/dev/null && test "$summary_limit" = "$2"
415 then
417 else
418 usage
420 shift
423 shift
424 break
427 usage
430 break
432 esac
433 shift
434 done
436 test $summary_limit = 0 && return
438 if rev=$(git rev-parse -q --verify "$1^0")
439 then
440 head=$rev
441 shift
442 else
443 head=HEAD
446 cd_to_toplevel
447 # Get modified modules cared by user
448 modules=$(git diff-index $cached --raw $head -- "$@" |
449 egrep '^:([0-7]* )?160000' |
450 while read mod_src mod_dst sha1_src sha1_dst status name
452 # Always show modules deleted or type-changed (blob<->module)
453 test $status = D -o $status = T && echo "$name" && continue
454 # Also show added or modified modules which are checked out
455 GIT_DIR="$name/.git" git-rev-parse --git-dir >/dev/null 2>&1 &&
456 echo "$name"
457 done
460 test -z "$modules" && return
462 git diff-index $cached --raw $head -- $modules |
463 egrep '^:([0-7]* )?160000' |
464 cut -c2- |
465 while read mod_src mod_dst sha1_src sha1_dst status name
467 if test -z "$cached" &&
468 test $sha1_dst = 0000000000000000000000000000000000000000
469 then
470 case "$mod_dst" in
471 160000)
472 sha1_dst=$(GIT_DIR="$name/.git" git rev-parse HEAD)
474 100644 | 100755 | 120000)
475 sha1_dst=$(git hash-object $name)
477 000000)
478 ;; # removed
480 # unexpected type
481 echo >&2 "unexpected mode $mod_dst"
482 continue ;;
483 esac
485 missing_src=
486 missing_dst=
488 test $mod_src = 160000 &&
489 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_src^0 >/dev/null &&
490 missing_src=t
492 test $mod_dst = 160000 &&
493 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_dst^0 >/dev/null &&
494 missing_dst=t
496 total_commits=
497 case "$missing_src,$missing_dst" in
499 errmsg=" Warn: $name doesn't contain commit $sha1_src"
502 errmsg=" Warn: $name doesn't contain commit $sha1_dst"
504 t,t)
505 errmsg=" Warn: $name doesn't contain commits $sha1_src and $sha1_dst"
508 errmsg=
509 total_commits=$(
510 if test $mod_src = 160000 -a $mod_dst = 160000
511 then
512 range="$sha1_src...$sha1_dst"
513 elif test $mod_src = 160000
514 then
515 range=$sha1_src
516 else
517 range=$sha1_dst
519 GIT_DIR="$name/.git" \
520 git log --pretty=oneline --first-parent $range | wc -l
522 total_commits=" ($(($total_commits + 0)))"
524 esac
526 sha1_abbr_src=$(echo $sha1_src | cut -c1-7)
527 sha1_abbr_dst=$(echo $sha1_dst | cut -c1-7)
528 if test $status = T
529 then
530 if test $mod_dst = 160000
531 then
532 echo "* $name $sha1_abbr_src(blob)->$sha1_abbr_dst(submodule)$total_commits:"
533 else
534 echo "* $name $sha1_abbr_src(submodule)->$sha1_abbr_dst(blob)$total_commits:"
536 else
537 echo "* $name $sha1_abbr_src...$sha1_abbr_dst$total_commits:"
539 if test -n "$errmsg"
540 then
541 # Don't give error msg for modification whose dst is not submodule
542 # i.e. deleted or changed to blob
543 test $mod_dst = 160000 && echo "$errmsg"
544 else
545 if test $mod_src = 160000 -a $mod_dst = 160000
546 then
547 limit=
548 test $summary_limit -gt 0 && limit="-$summary_limit"
549 GIT_DIR="$name/.git" \
550 git log $limit --pretty='format: %m %s' \
551 --first-parent $sha1_src...$sha1_dst
552 elif test $mod_dst = 160000
553 then
554 GIT_DIR="$name/.git" \
555 git log --pretty='format: > %s' -1 $sha1_dst
556 else
557 GIT_DIR="$name/.git" \
558 git log --pretty='format: < %s' -1 $sha1_src
560 echo
562 echo
563 done |
564 if test -n "$for_status"; then
565 echo "# Modified submodules:"
566 echo "#"
567 sed -e 's|^|# |' -e 's|^# $|#|'
568 else
573 # List all submodules, prefixed with:
574 # - submodule not initialized
575 # + different revision checked out
577 # If --cached was specified the revision in the index will be printed
578 # instead of the currently checked out revision.
580 # $@ = requested paths (default to all)
582 cmd_status()
584 # parse $args after "submodule ... status".
585 while test $# -ne 0
587 case "$1" in
588 -q|--quiet)
589 quiet=1
591 --cached)
592 cached=1
595 shift
596 break
599 usage
602 break
604 esac
605 shift
606 done
608 module_list "$@" |
609 while read mode sha1 stage path
611 name=$(module_name "$path") || exit
612 url=$(git config submodule."$name".url)
613 if test -z "$url" || ! test -d "$path"/.git -o -f "$path"/.git
614 then
615 say "-$sha1 $path"
616 continue;
618 set_name_rev "$path" "$sha1"
619 if git diff-files --quiet -- "$path"
620 then
621 say " $sha1 $path$revname"
622 else
623 if test -z "$cached"
624 then
625 sha1=$(unset GIT_DIR; cd "$path" && git rev-parse --verify HEAD)
626 set_name_rev "$path" "$sha1"
628 say "+$sha1 $path$revname"
630 done
633 # Sync remote urls for submodules
634 # This makes the value for remote.$remote.url match the value
635 # specified in .gitmodules.
637 cmd_sync()
639 while test $# -ne 0
641 case "$1" in
642 -q|--quiet)
643 quiet=1
644 shift
647 shift
648 break
651 usage
654 break
656 esac
657 done
658 cd_to_toplevel
659 module_list "$@" |
660 while read mode sha1 stage path
662 name=$(module_name "$path")
663 url=$(git config -f .gitmodules --get submodule."$name".url)
665 # Possibly a url relative to parent
666 case "$url" in
667 ./*|../*)
668 url=$(resolve_relative_url "$url") || exit
670 esac
672 if test -e "$path"/.git
673 then
675 unset GIT_DIR
676 cd "$path"
677 remote=$(get_default_remote)
678 say "Synchronizing submodule url for '$name'"
679 git config remote."$remote".url "$url"
682 done
685 # This loop parses the command line arguments to find the
686 # subcommand name to dispatch. Parsing of the subcommand specific
687 # options are primarily done by the subcommand implementations.
688 # Subcommand specific options such as --branch and --cached are
689 # parsed here as well, for backward compatibility.
691 while test $# != 0 && test -z "$command"
693 case "$1" in
694 add | foreach | init | update | status | summary | sync)
695 command=$1
697 -q|--quiet)
698 quiet=1
700 -b|--branch)
701 case "$2" in
703 usage
705 esac
706 branch="$2"; shift
708 --cached)
709 cached="$1"
712 break
715 usage
718 break
720 esac
721 shift
722 done
724 # No command word defaults to "status"
725 test -n "$command" || command=status
727 # "-b branch" is accepted only by "add"
728 if test -n "$branch" && test "$command" != add
729 then
730 usage
733 # "--cached" is accepted only by "status" and "summary"
734 if test -n "$cached" && test "$command" != status -a "$command" != summary
735 then
736 usage
739 "cmd_$command" "$@"